#ifndef __windows_inc__
#include "windows.inc"
#endif

#define TOKEN_STRING  0x00000001
#define TOKEN_COMMENT 0x00000002
#define TOKEN_OPERAND 0x00000004
#define TOKEN_NEWLINE 0x00000008
#define TOKEN_KEYWORD 0x00000010
#define TOKEN_INTEGER 0x00000020
#define TOKEN_HEX     0x00000040 | TOKEN_INTEGER
#define TOKEN_SPACE   0x00000080
#define TOKEN_TAB     0x00000100
#define TOKEN_PREPROC 0x00000200
#define TOKEN_IGNORE  0x00000400 // [set by application]
#define TOKEN_MAX     0x000007FF
#define TOKEN_DELETE  0x80000000 // [set by application] if set, FreeTokens should call delete text

#ifndef _tokenizer_
declare extern findchar(unsigned byte *bRefArray, int count, unsigned byte find),BOOL;
declare extern findword(unsigned word *wRefArray, int count, unsigned word find),BOOL;
declare extern CreateRootToken(int type, string *text, int textlen),token *;
#endif

//#define USE_INVALIDCHAR_LOG
//#define USE_CONSOLE_DEBUG
//#define USE_C_STYLE_DEBUG
//#define USE_COBJMACROS_DEBUG
//#define USE_GUIDS_DEBUG



struct token {
	token  *next;
	token  *prev;
	int     type;
	string *text; // points to raw data (not null terminated strings)
	int     textlen;
	void   *userdata;
}

struct deltoken {
	deltoken  *next;
	deltoken  *prev;
	token     *first;
	token     *last;
}
///////////////////////////////////////////////////////////////////////////////////

class CTokenizer
{
	declare CTokenizer();
	declare _CTokenizer();
	declare Tokenize(string *pInput, BOOL fEbasic, BOOL fPlainText),BOOL;
	declare GetTokens(token *ppToken),BOOL; // ok
	declare FreeTokens();
	declare SetError(string *szError, opt BOOL bRetval),BOOL; // ok
	declare GetError(opt void *ppszError),pointer;
	declare GetByte(byte *lpddress),byte; // to handle line numbers

	// add any new variables to CTokenizer :: CTokenizer() in memset(this+4, 0, 4*11);
	token         *m_token;
	deltoken      *m_deltoken;   // linked list with removed tokens
	unsigned byte  m_GetWord_prevbyte;
	BYTE          *m_pInvalid;
}
///////////////////////////////////////////////////////////////////////////////////



